/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.cicero.runtime@0.2.0

// imports

// Warning: Beware of circular dependencies when modifying these imports
import {IAccordContract,IAccordContractState} from './org.accordproject.cicero.contract@0.2.0';
import {IMonetaryAmount} from './org.accordproject.money@0.3.0';
import {ITransaction,IEvent,IParticipant,IConcept} from './concerto@1.0.0';

// interfaces
export interface IRequest extends ITransaction {
}

export interface IResponse extends ITransaction {
}

export interface IErrorResponse extends ITransaction {
}

export interface IObligation extends IEvent {
   contract: IAccordContract;
   promisor?: IParticipant;
   promisee?: IParticipant;
   deadline?: Date;
}

export type ObligationUnion = IPaymentObligation | 
INotificationObligation;

export interface IPaymentObligation extends IObligation {
   amount: IMonetaryAmount;
   description: string;
}

export interface INotificationObligation extends IObligation {
   title: string;
   message: string;
}

export interface IPayload extends IConcept {
   contract: IAccordContract;
   request: IRequest;
   state?: IAccordContractState;
}

export interface ISuccess extends IConcept {
   response: IResponse;
   state: IAccordContractState;
   emit: IEvent[];
}

export interface IFailure extends IConcept {
   error: IErrorResponse;
}

